/*
Youtube video: https://youtu.be/dKjynl9-9s0
Youtube channel:  https://www.youtube.com/channel/UC82y1uu7k08kq9SMpckNRoA
*/

// библиотека с командами для сервоприводов
#include <Servo.h> 

Servo servo1;  // servo /объект сервопривод 
int LED =2; // LED pin /контакт питания светодиода  
int servoPIN=7; //Servo pin /контакт сервопривода

unsigned long Pause=(long)12*60*60*1000;//feeding delay, ms/ 12h*60min*60sec*1000 // время между кормлением в мс = 12ч*60мин*60сек*1000

//int Pause=8000; // fot test

int Y0=5; // close angle /угол сервы в закрытом положении
int Y1=45; // close angle /угол сервы в открытом положении
int t=40; // delay for shake mode /приостановка в промежуточных положениях при открытии, мс (режим тряски)
 
void setup()
{
  pinMode(LED, OUTPUT); // LED выход
  LEDmig2(LED,  8); //led flash function 2 /мигнуть светодиодом выключателя быстро Х раза
  delay(1500); 
  //Serial.begin(9600); //test последовательный порт для отображения данных
}
 
void loop()
{
 // time=millis();
  
  LEDmig(LED, 3); //led flash function 1 /мигнуть светодиодом выключателя медленно Х раза
  digitalWrite(LED, LOW ); //выкл светодиод
  Open () ;//open function/ функция открытия крышки
  digitalWrite(LED, HIGH );  //включаем светодиод
 // Serial.println(Pause); //test
 
  delay(Pause); // wait next feeding //ждем до следующего кормления
 
} //loop



//********************** ФУНКЦИИ *****************************************
//***************************************************************

void Open() //open function //функция открытия крышки
{
  servo1.attach(servoPIN); // подкючаем сервопривод к цифровому выходу Х
  int pos; // position/ положение сервы
    
//----  open//цикл плавного открытия с шагом Х град.
  for(pos = Y0; pos < Y1; pos += 5) // шаг=угол
  {
    servo1.write(pos);  // передвинься на следующую позицию
    delay(20);               // небольшой перерыв чтобы он успел передвинуться
  }
     delay(20);               // небольшой перерыв 
//---- 
  
  
//---- close- shake mode / цикл зкрытия с потрясыванием
  for(pos = Y1; pos >= Y0; pos -= 8) //шаг=угол
  {                               
    servo1.write(pos);  // передвинься на следующую позицию
    delay(t);               // небольшой перерыв чтобы он успел передвинуться
    servo1.write(pos-5);  // чуть призакроем
    delay(t);
    servo1.write(pos);  // передвинься на следующую позицию
    delay(t);  
  }

//----  additional shaking /цикл дополнительной тряски в конце
  for(int i = 0; i <= 3; i += 1) //
  {
    servo1.write(14);  // передвинься на следующую позицию
    delay(400);
    servo1.write(Y0);     // повернись до уровня закрытия
        delay(200);
  }  
 //----  
 
    delay(1500); // пауза перед расслаблением

    servo1.detach(); //отключаем сервопривод
 
}

  //------------------------------------------------
  
  
 ///led flash function / функция мигания светодиода 1 (имя светодиода, кол-во миганий)
void LEDmig(int led_name, int count) 
{
  if (digitalRead(led_name) == HIGH) // если диод горит
  {
    digitalWrite(led_name, LOW ); // выкл светодиод 
  }
  
  for (int i=1; i <= count; i++) //мигаем
   {
     digitalWrite(led_name, HIGH ); // зажечь светодиод
     delay(400);
     digitalWrite(led_name, LOW ); // выкл светодиод
     delay(400);
   }
}

//////////////////////////////////////////////////

// функция мигания светодиода 2 другая скорость (имя светодиода, кол-во миганий)

void LEDmig2(int led_name, int count) 
{
  if (digitalRead(led_name) == HIGH) // если диод горит
  {
    digitalWrite(led_name, LOW ); // выкл светодиод 
  }
  
  for (int i=1; i <= count; i++) //мигаем
   {
     digitalWrite(led_name, HIGH ); // зажечь светодиод
     delay(120);
     digitalWrite(led_name, LOW ); // выкл светодиод
     delay(120);
   }
}



